attribute vec3 position;
attribute vec2 uv;
attribute vec4 color;
attribute vec3 normal;

uniform mat4 View;
uniform mat4 Proj;
uniform mat4 World;

uniform float LineWidth;

varying vec4 Color; 
varying vec2 TextureCoord; 
varying vec3 Normal; 

void main() {
	vec3 delta = normal * LineWidth;
	vec4 pos = vec4(position + delta, 1);
    gl_Position = Proj * View * pos;
    Normal = normal;
}